#!/usr/bin/perl -w
# spam1.pl
# Portscan a bunch of spammers from a directory full of e-mail.
# by Javantea
# Oct 7, 2006

# Usage: spam1.pl [file] [...]
# It will check as many files as you give it.
# If you don't give it any files, it will do 
# ls --sort=time junk2/cur/*
# to get a list of spam files.

# NOTE: Be careful running this. This does port scanning which might 
# cause people to get mad at you. I take no responsibility for your 
# actions. Flags are set to scan slowly (-T2 Polite), but that still 
# isn't enough to make paranoid people happy.

# For sample output, SEE sample_output1.txt.

# TODO:
# It's possible to modify the program to take stdin to get filenames.
# it would be like: ls --sort=time junk2/cur/* | head -n 30 | spam1.pl

use strict;
use spam4;

# For advanced use, switch the two below to 0 to skip the scans.
my $PING_SCAN = 1;
my $PORT_SCAN = 1;
my $PORTS = "21,22,23,25,37,53,80,113,135,139,443,445,1025,1433,3306,3389,5000,5800,5900,6000,6667,6881,6882,6883";

my @files;

if($#ARGV >= 0) {
	@files = @ARGV;
}
else {
	# Get a list of files, newest first.
	# Requires gnu compatible ls.
	my $sFiles = `ls --sort=time junk2/cur/*`;
	@files = split /\n/, $sFiles;
}

my @ips = ();
my $filename;
for $filename (@files) {
	my $ip = &checkFile($filename);
	# Only add unique ips.
	if(!(grep { $_  eq $ip } @ips)) {
		#print "$ip " . "\n";
		push(@ips, $ip);
	}
	else {
		#print "dupe: $ip\n";
	}
}

print "IPs: @ips\n";
print "\n";

sub checkUp()
{
	my $ip = $_;
#print "checkUp: $ip\n";
	open(PING1, "ping2/ping_$ip.xml") or return 0;
	while(<PING1>) {
		if($_ =~ /1 host up/) {
			# Perl sucks, why do I have to do this?
			$_ = $ip;
			return $_;
		}
	}
	return 0;
}

sub checkOpen()
{
	my ($ip, $port) = @_;
#print "checkOpen: $ip $port\n";
	open(PORT2, "port3/port2_$ip.xml") or return '';
	while(<PORT2>) {
		if($_ =~ /portid=\"$port\"\>\<state state=\"open/) {
			# Perl sucks, why do I have to do this?
			$_ = $ip;
			return $_;
		}
	}
	return '';
}

my @ips_up;

if($PING_SCAN) {
	my $ip;
	for $ip (@ips) {
		# Execute nmap ping each target.
		system("nmap -sP -T2 -vv -oX ping2/ping_$ip.xml $ip");
	}
	@ips_up  = grep  { &checkUp } @ips;
}
else {
	@ips_up = @ips;
}

@ips_up  = grep  { &checkUp } @ips;

print "IPs up: @ips_up\n";

if($PORT_SCAN) {
	my $ip;
	for $ip (@ips_up) {
		# Execute nmap connect on the target.
		system("nmap -sT -P0 -T2 -vv -p $PORTS -oX port3/port2_$ip.xml $ip");
	}
}
print "\n";

# Get a list of ips for each port.
my @ports = split /,/, $PORTS;

# To see which targets have a certain port open.
print "IPs by port:\n";

my $port;
for $port (@ports) {
	print "$port : ";
	my $ip;
	for $ip (@ips_up) {
		my $ip_out = &checkOpen($ip, $port);
		print "$ip_out ";
	}
	print "\n";
}
print "\n";

# To see which ports a certain target has open.
print "Ports by IP:\n";
my $ip;
for $ip (@ips_up) {
	print "$ip : ";
	for $port (@ports) {
		my $ip_out = &checkOpen($ip, $port);
		if($ip_out ne '') {
			print "$port ";
		}
	}
	print "\n";
}

exit 0;
